{
	YT (demoonlit@panathenaia.halfmoon.jp)
	06 Novemebr 2007
	Modified for libpng 1.2.22, 
	static linking and changed from stdcall to fastcall.
	And renamed PngDef.pas to PNG.pas.

	Dominique Louis ( Dominique@SavageSoftware.com.au )
	22 Novemebr 2000
	Added $IFDEF so that users can decide at compile time,
	which version of the DLL they wish to use.

	Dominique Louis ( Dominique@SavageSoftware.com.au )
	13 June 2000
	This file has been updated to version 1.0.6 of PNGLIB.
	More data structures and functions within the DLL have been added,
	I have also added a few more Delphi style types.

	Uberto Barbini (uberto@usa.net)
	14 Dec 1999.
	This file contains all the Pascal data structures,
	and declarations of the procedures and functions you can call in the DLL.
}

unit PNG;

{$DEFINE PNG_STATIC}
{x$DEFINE PNG_NO_READ_SUPPORTED}
{x$DEFINE PNG_NO_WRITE_SUPPORTED}
{x$DEFINE PNG_NO_MNG_FEATURES}
{x$DEFINE PNG_NO_FLOATING_POINT_SUPPORTED}
{x$DEFINE PNG_NO_SETJMP_SUPPORTED}
{x$DEFINE PNG_NO_FIXED_POINT_SUPPORTED}
{x$DEFINE PNG_NO_ERROR_NUMBERS}
{x$DEFINE PNG_NO_USER_TRANSFORM_PTR}
{$DEFINE PNG_NO_STDIO}
{x$DEFINE PNG_NO_EASY_ACCESS}
{x$DEFINE PNG_NO_USER_MEM}
{x$DEFINE PNG_NO_SET_USER_LIMITS}
{x$DEFINE PNG_NO_READ_ANCILLARY_CHUNKS}
{x$DEFINE PNG_NO_WRITE_ANCILLARY_CHUNKS}
{x$DEFINE PNG_NO_INFO_IMAGE}
{x$DEFINE PNG_NO_ERROR_TEXT}

interface

uses
	zlibpas;

{$IFNDEF PNG_STATIC}
const
	libpng = 'lpng-px.dll';
{$ENDIF}

const
	PNG_LIBPNG_VER_STRING = '1.2.22';
	PNG_HEADER_VERSION_STRING = ' libpng version 1.2.22 - October 13, 2007'#10;

	PNG_LIBPNG_VER_SONUM = 0;
	PNG_LIBPNG_VER_DLLNUM = 13;

	PNG_LIBPNG_VER_MAJOR = 1;
	PNG_LIBPNG_VER_MINOR = 2;
	PNG_LIBPNG_VER_RELEASE = 22;

	PNG_LIBPNG_VER_BUILD = 0;

	PNG_LIBPNG_VER = 10222;

	PNG_LIBPNG_BUILD_ALPHA = 1;
	PNG_LIBPNG_BUILD_BETA = 2;
	PNG_LIBPNG_BUILD_RC = 3;
	PNG_LIBPNG_BUILD_STABLE = 4;
	PNG_LIBPNG_BUILD_RELEASE_STATUS_MASK = 7;
	PNG_LIBPNG_BUILD_PATCH = 8;
	PNG_LIBPNG_BUILD_PRIVATE = 16;
	PNG_LIBPNG_BUILD_SPECIAL = 32;

	PNG_LIBPNG_BUILD_BASE_TYPE = PNG_LIBPNG_BUILD_STABLE;

{--- pngconf.h ---}

{$DEFINE PNG_1_2_X}

{$IFNDEF PNG_NO_READ_SUPPORTED}
{$DEFINE PNG_READ_SUPPORTED}
{$ENDIF}

{$IFNDEF PNG_NO_WRITE_SUPPORTED}
{$DEFINE PNG_WRITE_SUPPORTED}
{$ENDIF}

{$IFNDEF PNG_NO_MNG_FEATURES}
{$DEFINE PNG_MNG_FEATURES_SUPPORTED}
{$ENDIF}

{$IFNDEF PNG_NO_FLOATING_POINT_SUPPORTED}
{$DEFINE PNG_FLOATING_POINT_SUPPORTED}
{$ENDIF}

{$IFDEF PNG_NO_STDIO}
{$DEFINE PNG_NO_CONSOLE_IO}
{$ENDIF}

{$IFNDEF PNG_NO_SETJMP_SUPPORTED}
{$DEFINE PNG_SETJMP_SUPPORTED}
{$ENDIF}

const
	PNG_DITHER_RED_BITS = 5;
	PNG_DITHER_GREEN_BITS = 5;
	PNG_DITHER_BLUE_BITS = 5;

	PNG_MAX_GAMMA_8 = 11;
	PNG_GAMMA_THRESHOLD = 0.05;

{$DEFINE PNG_NO_ITXT_SUPPORTED}
{$DEFINE PNG_NO_READ_ITXT}
{$DEFINE PNG_NO_WRITE_ITXT}

{$IFNDEF PNG_NO_FIXED_POINT_SUPPORTED}
{$DEFINE PNG_FIXED_POINT_SUPPORTED}
{$ENDIF}

{$IFNDEF PNG_NO_FREE_ME}
{$DEFINE PNG_FREE_ME_SUPPORTED}
{$ENDIF}

{$IFDEF PNG_READ_SUPPORTED}
{$DEFINE PNG_READ_TRANSFORMS_SUPPORTED}
{$DEFINE PNG_READ_EXPAND_SUPPORTED}
{$DEFINE PNG_READ_SHIFT_SUPPORTED}
{$DEFINE PNG_READ_PACK_SUPPORTED}
{$DEFINE PNG_READ_BGR_SUPPORTED}
{$DEFINE PNG_READ_SWAP_SUPPORTED}
{$DEFINE PNG_READ_PACKSWAP_SUPPORTED}
{$DEFINE PNG_READ_INVERT_SUPPORTED}
{$DEFINE PNG_READ_DITHER_SUPPORTED}
{$DEFINE PNG_READ_BACKGROUND_SUPPORTED}
{$DEFINE PNG_READ_16_TO_8_SUPPORTED}
{$DEFINE PNG_READ_FILLER_SUPPORTED}
{$DEFINE PNG_READ_GAMMA_SUPPORTED}
{$DEFINE PNG_READ_GRAY_TO_RGB_SUPPORTED}
{$DEFINE PNG_READ_SWAP_ALPHA_SUPPORTED}
{$DEFINE PNG_READ_INVERT_ALPHA_SUPPORTED}
{$DEFINE PNG_READ_STRIP_ALPHA_SUPPORTED}
{$DEFINE PNG_READ_USER_TRANSFORM_SUPPORTED}
{$DEFINE PNG_READ_RGB_TO_GRAY_SUPPORTED}
{$DEFINE PNG_PROGRESSIVE_READ_SUPPORTED}
{$DEFINE PNG_READ_INTERLACING_SUPPORTED}
{$DEFINE PNG_READ_COMPOSITE_NODIV_SUPPORTED}
{$DEFINE PNG_READ_EMPTY_PLTE_SUPPORTED}
{$ENDIF}

{$IFDEF PNG_WRITE_SUPPORTED}
{$DEFINE PNG_WRITE_TRANSFORMS_SUPPORTED}
{$DEFINE PNG_WRITE_SHIFT_SUPPORTED}
{$DEFINE PNG_WRITE_PACK_SUPPORTED}
{$DEFINE PNG_WRITE_BGR_SUPPORTED}
{$DEFINE PNG_WRITE_SWAP_SUPPORTED}
{$DEFINE PNG_WRITE_PACKSWAP_SUPPORTED}
{$DEFINE PNG_WRITE_INVERT_SUPPORTED}
{$DEFINE PNG_WRITE_FILLER_SUPPORTED}
{$DEFINE PNG_WRITE_SWAP_ALPHA_SUPPORTED}
{$DEFINE PNG_WRITE_INVERT_ALPHA_SUPPORTED}
{$DEFINE PNG_WRITE_USER_TRANSFORM_SUPPORTED}
{$DEFINE PNG_WRITE_INTERLACING_SUPPORTED}
{$DEFINE PNG_WRITE_WEIGHTED_FILTER_SUPPORTED}
{$DEFINE PNG_WRITE_FLUSH_SUPPORTED}
{$DEFINE PNG_WRITE_EMPTY_PLTE_SUPPORTED}
{$ENDIF}

{$IFNDEF PNG_NO_ERROR_NUMBERS}
{$DEFINE PNG_ERROR_NUMBERS_SUPPORTED}
{$ENDIF}

{$IFNDEF PNG_NO_USER_TRANSFORM_PTR}
{$DEFINE PNG_USER_TRANSFORM_PTR_SUPPORTED}
{$ENDIF}

{$IFNDEF PNG_NO_STDIO}
{$DEFINE PNG_TIME_RFC1123_SUPPORTED}
{$ENDIF}

{$IFNDEF PNG_NO_EASY_ACCESS}
{$DEFINE PNG_EASY_ACCESS_SUPPORTED}
{$ENDIF}

{$IFNDEF PNG_NO_USER_MEM}
{$DEFINE PNG_USER_MEM_SUPPORTED}
{$ENDIF}

{$IFNDEF PNG_NO_SET_USER_LIMITS}
{$DEFINE PNG_SET_USER_LIMITS_SUPPORTED}
{$ENDIF}

const
	PNG_USER_WIDTH_MAX = 1000000;
	PNG_USER_HEIGHT_MAX = 1000000;

{$IFDEF PNG_READ_SUPPORTED}
{$DEFINE PNG_READ_16_TO_8_ACCURATE_SCALE_SUPPORTED}
{$ENDIF}

{$DEFINE PNG_READ_BIG_ENDIAN_SUPPORTED}

{$DEFINE PNG_USELESS_TESTS_SUPPORTED}
{$DEFINE PNG_CORRECT_PALETTE_SUPPORTED}

{$IFNDEF PNG_NO_READ_ANCILLARY_CHUNKS}
{$DEFINE PNG_READ_ANCILLARY_CHUNKS_SUPPORTED}
{$ENDIF}

{$IFNDEF PNG_NO_WRITE_ANCILLARY_CHUNKS}
{$DEFINE PNG_WRITE_ANCILLARY_CHUNKS_SUPPORTED}
{$ENDIF}

{$IFDEF PNG_READ_ANCILLARY_CHUNKS_SUPPORTED}
{$DEFINE PNG_READ_BKGD_SUPPORTED}
{$DEFINE PNG_BKGD_SUPPORTED}
{$DEFINE PNG_READ_CHRM_SUPPORTED}
{$DEFINE PNG_CHRM_SUPPORTED}
{$DEFINE PNG_READ_GAMA_SUPPORTED}
{$DEFINE PNG_GAMA_SUPPORTED}
{$DEFINE PNG_READ_HIST_SUPPORTED}
{$DEFINE PNG_HIST_SUPPORTED}
{$DEFINE PNG_READ_ICCP_SUPPORTED}
{$DEFINE PNG_ICCP_SUPPORTED}
{$IFNDEF PNG_NO_READ_ITXT}
{$DEFINE PNG_READ_ITXT_SUPPORTED}
{$DEFINE PNG_ITXT_SUPPORTED}
{$ENDIF}
{$DEFINE PNG_READ_OFFS_SUPPORTED}
{$DEFINE PNG_OFFS_SUPPORTED}
{$DEFINE PNG_READ_PCAL_SUPPORTED}
{$DEFINE PNG_PCAL_SUPPORTED}
{$DEFINE PNG_READ_SCAL_SUPPORTED}
{$DEFINE PNG_SCAL_SUPPORTED}
{$DEFINE PNG_READ_PHYS_SUPPORTED}
{$DEFINE PNG_PHYS_SUPPORTED}
{$DEFINE PNG_READ_SBIT_SUPPORTED}
{$DEFINE PNG_SBIT_SUPPORTED}
{$DEFINE PNG_READ_SPLT_SUPPORTED}
{$DEFINE PNG_SPLT_SUPPORTED}
{$DEFINE PNG_READ_SRGB_SUPPORTED}
{$DEFINE PNG_SRGB_SUPPORTED}
{$DEFINE PNG_READ_TEXT_SUPPORTED}
{$DEFINE PNG_TEXT_SUPPORTED}
{$DEFINE PNG_READ_TIME_SUPPORTED}
{$DEFINE PNG_TIME_SUPPORTED}
{$DEFINE PNG_READ_TRNS_SUPPORTED}
{$DEFINE PNG_TRNS_SUPPORTED}
{$DEFINE PNG_READ_ZTXT_SUPPORTED}
{$DEFINE PNG_ZTXT_SUPPORTED}
{$DEFINE PNG_READ_UNKNOWN_CHUNKS_SUPPORTED}
{$DEFINE PNG_UNKNOWN_CHUNKS_SUPPORTED}
{$DEFINE PNG_HANDLE_AS_UNKNOWN_SUPPORTED}
{$DEFINE PNG_READ_USER_CHUNKS_SUPPORTED}
{$DEFINE PNG_USER_CHUNKS_SUPPORTED}
{$DEFINE PNG_READ_OPT_PLTE_SUPPORTED}
{$DEFINE PNG_READ_TEXT_SUPPORTED}
{$DEFINE PNG_TEXT_SUPPORTED}
{$ENDIF}

{$IFDEF PNG_WRITE_ANCILLARY_CHUNKS_SUPPORTED}
{$DEFINE PNG_WRITE_BKGD_SUPPORTED}
{$DEFINE PNG_BKGD_SUPPORTED}
{$DEFINE PNG_WRITE_CHRM_SUPPORTED}
{$DEFINE PNG_CHRM_SUPPORTED}
{$DEFINE PNG_WRITE_GAMA_SUPPORTED}
{$DEFINE PNG_GAMA_SUPPORTED}
{$DEFINE PNG_WRITE_HIST_SUPPORTED}
{$DEFINE PNG_HIST_SUPPORTED}
{$DEFINE PNG_WRITE_ICCP_SUPPORTED}
{$DEFINE PNG_ICCP_SUPPORTED}
{$DEFINE PNG_WRITE_ITXT_SUPPORTED}
{$DEFINE PNG_ITXT_SUPPORTED}
{$DEFINE PNG_WRITE_OFFS_SUPPORTED}
{$DEFINE PNG_OFFS_SUPPORTED}
{$DEFINE PNG_WRITE_PCAL_SUPPORTED}
{$DEFINE PNG_PCAL_SUPPORTED}
{$DEFINE PNG_WRITE_SCAL_SUPPORTED}
{$DEFINE PNG_SCAL_SUPPORTED}
{$DEFINE PNG_WRITE_PHYS_SUPPORTED}
{$DEFINE PNG_PHYS_SUPPORTED}
{$DEFINE PNG_WRITE_SBIT_SUPPORTED}
{$DEFINE PNG_SBIT_SUPPORTED}
{$DEFINE PNG_WRITE_SPLT_SUPPORTED}
{$DEFINE PNG_SPLT_SUPPORTED}
{$DEFINE PNG_WRITE_SRGB_SUPPORTED}
{$DEFINE PNG_SRGB_SUPPORTED}
{$DEFINE PNG_WRITE_TEXT_SUPPORTED}
{$DEFINE PNG_TEXT_SUPPORTED}
{$DEFINE PNG_WRITE_TIME_SUPPORTED}
{$DEFINE PNG_TIME_SUPPORTED}
{$DEFINE PNG_WRITE_TRNS_SUPPORTED}
{$DEFINE PNG_TRNS_SUPPORTED}
{$DEFINE PNG_WRITE_ZTXT_SUPPORTED}
{$DEFINE PNG_ZTXT_SUPPORTED}
{$DEFINE PNG_WRITE_UNKNOWN_CHUNKS_SUPPORTED}
{$DEFINE PNG_UNKNOWN_CHUNKS_SUPPORTED}
{$DEFINE PNG_HANDLE_AS_UNKNOWN_SUPPORTED}
{$DEFINE PNG_WRITE_TEXT_SUPPORTED}
{$DEFINE PNG_TEXT_SUPPORTED}
{$ENDIF}

{$IFNDEF PNG_NO_INFO_IMAGE}
{$DEFINE PNG_INFO_IMAGE_SUPPORTED}
{$ENDIF}

type
	time_t = Longint;

	{struct tm of Borland C++}
	ptm = ^tm;
	tm = record
		tm_sec: Integer;
		tm_min: Integer;
		tm_hour: Integer;
		tm_mday: Integer;
		tm_mon: Integer;
		tm_year: Integer;
		tm_wday: Integer;
		tm_yday: Integer;
		tm_isdst: Integer;
	end;

type
	png_uint_32 = LongWord;
	png_int_32 = LongInt;
	png_uint_16 = Word;
	png_int_16 = SmallInt;
	png_byte = Byte;

	png_size_t = Cardinal;

	png_fixed_point = png_int_32;

	png_voidp = pointer;
	png_bytep = ^png_byte;
	png_uint_32p = ^png_uint_32;
	png_int_32p = ^png_int_32;
	png_uint_16p = ^png_uint_16;
	png_int_16p = ^png_int_16;
	png_const_charp = PChar;
	png_charp = PChar;
	png_fixed_point_p = ^png_fixed_point;

{$IFNDEF PNG_NO_STDIO}
	png_FILE_p = Pointer;
{$ENDIF}

{$IFDEF PNG_FLOATING_POINT_SUPPORTED}
	png_doublep = ^Double;
{$ENDIF}

	png_bytepp = ^png_bytep;
	png_uint_32pp = ^png_uint_32p;
	png_int_32pp = ^png_int_32p;
	png_uint_16pp = ^png_uint_16p;
	png_int_16pp = ^png_int_16p;
	png_const_charpp = PPChar;
	png_charpp = PPChar;
	png_fixed_point_pp = ^png_fixed_point_p;

{$IFDEF PNG_FLOATING_POINT_SUPPORTED}
	png_doublepp = ^png_doublep;
{$ENDIF}

	png_charppp = ^png_charpp;

{--- end of pngconf.h ---}

const
	PNG_LIBPNG_BUILD_TYPE = PNG_LIBPNG_BUILD_BASE_TYPE;

type
	png_color = record
		red: png_byte;
		green: png_byte;
		blue: png_byte;
	end;
	png_colorp = ^png_color;
	png_colorpp = ^png_colorp;

	png_color_16 = record
		index: png_byte;
		red: png_uint_16;
		green: png_uint_16;
		blue: png_uint_16;
		gray: png_uint_16;
	end;
	png_color_16p = ^png_color_16;
	png_color_16pp = ^png_color_16p;

	png_color_8 = record
		red: png_byte;
		green: png_byte;
		blue: png_byte;
		gray: png_byte;
		alpha: png_byte;
	end;
	png_color_8p = ^png_color_8;
	png_color_8pp = ^png_color_8p;

	png_sPLT_entry = record
		red: png_uint_16;
		green: png_uint_16;
		blue: png_uint_16;
		alpha: png_uint_16;
		frequency: png_uint_16;
	end;
	png_sPLT_entryp = ^png_sPLT_entry;
	png_sPLT_entrypp = ^png_sPLT_entryp;

	png_sPLT_t = record
		name: png_charp;
		depth: png_byte;
		entries: png_sPLT_entryp;
		nentries: png_int_32;
	end;
	png_sPLT_tp = ^png_sPLT_t;
	png_sPLT_tpp = ^png_sPLT_tp;

{$IFDEF PNG_TEXT_SUPPORTED}
	png_text = record
		compression: Integer;
		key: png_charp;
		text: png_charp;
		text_length: png_size_t;
{$IFDEF PNG_iTXt_SUPPORTED}
		itxt_length: png_size_t;
		lang: png_charp;
		lang_key: png_charp;
{$ENDIF}
	end;
	png_textp = ^png_text;
	png_textpp = ^png_textp;
{$ENDIF}

const
	PNG_TEXT_COMPRESSION_NONE_WR = -3;
	PNG_TEXT_COMPRESSION_zTXt_WR = -2;
	PNG_TEXT_COMPRESSION_NONE = -1;
	PNG_TEXT_COMPRESSION_zTXt = 0;
	PNG_ITXT_COMPRESSION_NONE = 1;
	PNG_ITXT_COMPRESSION_zTXt = 2;
	PNG_TEXT_COMPRESSION_LAST = 3;

type
	png_time = packed record
		year: png_uint_16;
		month: png_byte;
		day: png_byte;
		hour: png_byte;
		minute: png_byte;
		second: png_byte;
	end;
	png_timep = ^png_time;
	png_timepp = ^png_timep;

{$IFDEF PNG_UNKNOWN_CHUNKS_SUPPORTED}
	png_unknown_chunk = record
		name: array[0..4] of png_byte;
		data: ^png_byte;
		size: png_size_t;
		location: png_byte;
	end;
	png_unknown_chunkp = ^png_unknown_chunk;
	png_unknown_chunkpp = ^png_unknown_chunkp;
{$ENDIF}

	png_infop = Pointer; {...}
	png_infopp = ^png_infop;

const
	PNG_UINT_31_MAX = png_uint_32($7fffffff);
	PNG_UINT_32_MAX = png_uint_32(-1);
	PNG_SIZE_MAX = png_size_t(-1);
	PNG_MAX_UINT = PNG_UINT_31_MAX;

	PNG_COLOR_MASK_PALETTE = 1;
	PNG_COLOR_MASK_COLOR = 2;
	PNG_COLOR_MASK_ALPHA = 4;

	PNG_COLOR_TYPE_GRAY = 0;
	PNG_COLOR_TYPE_PALETTE = PNG_COLOR_MASK_COLOR or PNG_COLOR_MASK_PALETTE;
	PNG_COLOR_TYPE_RGB = PNG_COLOR_MASK_COLOR;
	PNG_COLOR_TYPE_RGB_ALPHA = PNG_COLOR_MASK_COLOR or PNG_COLOR_MASK_ALPHA;
	PNG_COLOR_TYPE_GRAY_ALPHA = PNG_COLOR_MASK_ALPHA;

	PNG_COLOR_TYPE_RGBA = PNG_COLOR_TYPE_RGB_ALPHA;
	PNG_COLOR_TYPE_GA = PNG_COLOR_TYPE_GRAY_ALPHA;

	PNG_COMPRESSION_TYPE_BASE = 0;
	PNG_COMPRESSION_TYPE_DEFAULT = PNG_COMPRESSION_TYPE_BASE;

	PNG_FILTER_TYPE_BASE = 0;
	PNG_INTRAPIXEL_DIFFERENCING = 64;
	PNG_FILTER_TYPE_DEFAULT = PNG_FILTER_TYPE_BASE;

	PNG_INTERLACE_NONE = 0;
	PNG_INTERLACE_ADAM7 = 1;
	PNG_INTERLACE_LAST = 2;

	PNG_OFFSET_PIXEL = 0;
	PNG_OFFSET_MICROMETER = 1;
	PNG_OFFSET_LAST = 2;

	PNG_EQUATION_LINEAR = 0;
	PNG_EQUATION_BASE_E = 1;
	PNG_EQUATION_ARBITRARY = 2;
	PNG_EQUATION_HYPERBOLIC = 3;
	PNG_EQUATION_LAST = 4;

	PNG_SCALE_UNKNOWN = 0;
	PNG_SCALE_METER = 1;
	PNG_SCALE_RADIAN = 2;
	PNG_SCALE_LAST = 3;

	PNG_RESOLUTION_UNKNOWN = 0;
	PNG_RESOLUTION_METER = 1;
	PNG_RESOLUTION_LAST = 2;

	PNG_sRGB_INTENT_PERCEPTUAL = 0;
	PNG_sRGB_INTENT_RELATIVE = 1;
	PNG_sRGB_INTENT_SATURATION = 2;
	PNG_sRGB_INTENT_ABSOLUTE = 3;
	PNG_sRGB_INTENT_LAST = 4;

	PNG_KEYWORD_MAX_LENGTH = 79;

	PNG_MAX_PALETTE_LENGTH = 256;

	PNG_INFO_gAMA = $0001;
	PNG_INFO_sBIT = $0002;
	PNG_INFO_cHRM = $0004;
	PNG_INFO_PLTE = $0008;
	PNG_INFO_tRNS = $0010;
	PNG_INFO_bKGD = $0020;
	PNG_INFO_hIST = $0040;
	PNG_INFO_pHYs = $0080;
	PNG_INFO_oFFs = $0100;
	PNG_INFO_tIME = $0200;
	PNG_INFO_pCAL = $0400;
	PNG_INFO_sRGB = $0800;
	PNG_INFO_iCCP = $1000;
	PNG_INFO_sPLT = $2000;
	PNG_INFO_sCAL = $4000;
	PNG_INFO_IDAT = $8000;

type
	png_row_info = record
		width: png_uint_32;
		rowbytes: png_size_t;
		color_type: png_byte;
		bit_depth: png_byte;
		channels: png_byte;
		pixel_depth: png_byte;
	end;
	png_row_infop = ^png_row_info;
	png_row_infopp = ^png_row_infop;

	png_structp = Pointer; {...}

	png_error_ptr = procedure(png_ptr: png_structp; msg: png_const_charp); register;
	png_rw_ptr = procedure(png_ptr: png_structp; data: png_bytep; length: png_size_t); register;
	png_flush_ptr = procedure(png_ptr: png_structp); register;
	png_read_status_ptr = procedure(png_ptr: png_structp; row: png_uint_32; pass: Integer); register;
	png_write_status_ptr = procedure(png_ptr: png_structp; row: png_uint_32; pass: Integer); register;

{$IFDEF PNG_PROGRESSIVE_READ_SUPPORTED}
	png_progressive_info_ptr = procedure(png_ptr: png_structp; info_ptr: png_infop); register;
	png_progressive_end_ptr = procedure(png_ptr: png_structp; info_ptr: png_infop); register;
	png_progressive_row_ptr = procedure(png_ptr: png_structp; new_row: png_bytep; row_num: png_uint_32; pass: Integer); register;
{$ENDIF}

{$IF DEFINED(PNG_READ_USER_TRANSFORM_SUPPORTED) OR DEFINED(PNG_WRITE_USER_TRANSFORM_SUPPORTED) OR DEFINED(PNG_LEGACY_SUPPORTED)}
	png_user_transform_ptr = procedure(png_ptr: png_structp; row_info: png_row_infop; data: png_bytep); register;
{$IFEND}

{$IFDEF PNG_USER_CHUNKS_SUPPORTED}
	png_user_chunk_ptr = procedure(png_ptr: png_structp; chunk: png_unknown_chunkp); register;
{$ENDIF}
{$IFDEF PNG_UNKNOWN_CHUNKS_SUPPORTED}
	png_unknown_chunk_ptr = procedure(png_ptr: png_structp); register;
{$ENDIF}

const
	PNG_TRANSFORM_IDENTITY = $0000;
	PNG_TRANSFORM_STRIP_16 = $0001;
	PNG_TRANSFORM_STRIP_ALPHA = $0002;
	PNG_TRANSFORM_PACKING = $0004;
	PNG_TRANSFORM_PACKSWAP = $0008;
	PNG_TRANSFORM_EXPAND = $0010;
	PNG_TRANSFORM_INVERT_MONO = $0020;
	PNG_TRANSFORM_SHIFT = $0040;
	PNG_TRANSFORM_BGR = $0080;
	PNG_TRANSFORM_SWAP_ALPHA = $0100;
	PNG_TRANSFORM_SWAP_ENDIAN = $0200;
	PNG_TRANSFORM_INVERT_ALPHA = $0200;
	PNG_TRANSFORM_STRIP_FILLER = $0800;

	PNG_FLAG_MNG_EMPTY_PLTE = $01;
	PNG_FLAG_MNG_FILTER_64 = $04;
	PNG_ALL_MNG_FEATURES = $05;

type
	png_malloc_ptr = function(png_ptr: png_structp; size: png_size_t): png_voidp; register;
	png_free_ptr = procedure(png_ptr: png_structp; memory: png_voidp); register;

	version_1_2_22 = png_structp;

	png_structpp = ^png_structp;

function png_access_version_number: png_uint_32; register;

	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_sig_bytes(png_ptr: png_structp; num_bytes: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
function png_sig_cmp(sig: png_bytep; start: png_size_t; num_to_check: png_size_t): Integer; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
function png_check_sig(sig: png_bytep; num: Integer): Integer; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_create_read_struct(user_png_ver: png_const_charp; 
	error_ptr: png_voidp; error_fn: png_error_ptr; warn_fn: png_error_ptr): png_structp; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
function png_create_write_struct(user_png_ver: png_const_charp;
	error_ptr: png_voidp; error_fn: png_error_ptr; warn_fn: png_error_ptr): png_structp; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

{$IFDEF PNG_WRITE_SUPPORTED}
function png_get_compression_buffer_size(png_ptr: png_structp): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$ENDIF}

{$IFDEF PNG_WRITE_SUPPORTED}
procedure png_set_compression_buffer_size(png_ptr: png_structp; size: png_uint_32); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$ENDIF}

function png_reset_zstream(png_ptr: png_structp): Integer; register;

	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

{$IFDEF PNG_USER_MEM_SUPPORTED}
function png_create_read_struct_2(user_png_ver: png_const_charp;
	error_ptr: png_voidp; error_fn: png_error_ptr; warn_fn: png_error_ptr): png_structp; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
function png_create_write_struct_2(user_png_ver: png_const_charp;
	error_ptr: png_voidp; error_fn: png_error_ptr; warn_fn: png_error_ptr): png_structp; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

{$ENDIF}

procedure png_write_chunk(png_ptr: png_structp; chunk_name: png_bytep; data: png_bytep; length: png_size_t); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
procedure png_write_chunk_start(png_ptr: png_structp; chunk_name: png_bytep; length: png_uint_32); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
procedure png_write_chunk_data(png_ptr: png_structp; data: png_bytep; length: png_size_t); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
procedure png_write_chunk_end(png_ptr: png_structp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_create_info_struct(png_ptr: png_structp): png_infop; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

{...png_info_init...}

procedure png_info_init_3(info_ptr: png_infopp; png_info_struct_size: png_size_t); register;

	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_write_info_before_PLTE(png_ptr: png_structp; info_ptr: png_infop); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
procedure png_write_info(png_ptr: png_structp; info_ptr: png_infop); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

{$IFNDEF PNG_NO_SEQUENTIAL_READ_SUPPORTED}
procedure png_read_info(png_ptr: png_structp; info_ptr: png_infop); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$ENDIF}

{$IFDEF PNG_TIME_RFC1123_SUPPORTED}
function png_convert_to_rfc1123(png_ptr: png_structp; ptime: png_timep): png_charp; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$ENDIF}

{$IFDEF PNG_WRITE_tIME_SUPPORTED}
procedure png_convert_from_struct_tm(ptime: png_timep; ttime: ptm); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
procedure png_convert_from_time_t(ptime: png_timep; ttime: time_t); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

{$ENDIF}

{$IFDEF PNG_READ_EXPAND_SUPPORTED}
procedure png_set_expand(png_ptr: png_structp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$IFNDEF PNG_1_0_X}
procedure png_set_expand_gray_1_2_4_to_8(png_ptr: png_structp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$ENDIF}
procedure png_set_palette_to_rgb(png_ptr: png_structp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
procedure png_set_tRNS_to_alpha(png_ptr: png_structp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{...png_set_gray_1_2_4_to_8...}
{$ENDIF}

{$IF DEFINED(PNG_READ_BGR_SUPPORTED) OR DEFINED(PNG_WRITE_BGR_SUPPORTED)}
procedure png_set_bgr(png_ptr: png_structp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$IFEND}

{$IFDEF PNG_READ_GRAY_TO_RGB_SUPPORTED}
procedure png_set_gray_to_rgb(png_ptr: png_structp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$ENDIF}

{$IFDEF PNG_READ_RGB_TO_GRAY_SUPPORTED}
{$IFDEF PNG_FLOATING_POINT_SUPPORTED}
procedure png_set_rgb_to_gray(png_ptr: png_structp; error_action: Integer; red_weight, green_weight: double); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$ENDIF}
procedure png_set_rgb_to_gray_fixed(png_ptr: png_structp; error_action: Integer; red_weight, green_weight: png_fixed_point); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
function png_get_rgb_to_gray_status(png_ptr: png_structp) : png_byte; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

{$ENDIF}

procedure png_build_grayscale_palette(bit_depth: Integer; palette: png_colorp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

{$IFDEF PNG_READ_STRIP_ALPHA_SUPPORTED}
procedure png_set_strip_alpha(png_ptr: png_structp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

{$ENDIF}

{$IF DEFINED(PNG_READ_SWAP_ALPHA_SUPPORTED) OR DEFINED(PNG_WRITE_SWAP_ALPHA_SUPPORTED)}
procedure png_set_swap_alpha(png_ptr: png_structp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

{$IFEND}

{$IF DEFINED(PNG_READ_INVERT_ALPHA_SUPPORTED) OR DEFINED(PNG_WRITE_INVERT_ALPHA_SUPPORTED)}
procedure png_set_invert_alpha(png_ptr: png_structp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

{$IFEND}

{...}

{$IFDEF PNG_READ_BACKGROUND_SUPPORTED}
{$IFDEF PNG_FLOATING_POINT_SUPPORTED}
procedure png_set_background(png_ptr: png_structp; background_color: png_color_16p; background_gamma_code, need_expand: Integer; background_gamma: double); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$ENDIF}
const
	PNG_BACKGROUND_GAMMA_UNKNOWN = 0;
	PNG_BACKGROUND_GAMMA_SCREEN = 1;
	PNG_BACKGROUND_GAMMA_FILE = 2;
	PNG_BACKGROUND_GAMMA_UNIQUE = 3;
{$ENDIF}

{...}

{$IFDEF PNG_WRITE_FLUSH_SUPPORTED}
procedure png_set_flush(png_ptr: png_structp; nrows: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
procedure png_write_flush(png_ptr: png_structp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$ENDIF}

{...}

procedure png_destroy_info_struct(png_ptr: png_structp; info_ptr_ptr: png_infopp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_destroy_read_struct(png_ptr_ptr: png_structpp; info_ptr_ptr, end_info_ptr_ptr: png_infopp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

{...skip png_read_destroy...}

procedure png_destroy_write_struct(png_ptr_ptr: png_structpp; info_ptr_ptr: png_infopp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

{...skip png_write_destroy...}

procedure png_set_crc_action(png_ptr: png_structp; crit_action, ancil_action: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

const
	PNG_CRC_DEFAULT = 0;
	PNG_CRC_ERROR_QUIT = 1;
	PNG_CRC_WARN_DISCARD = 2;
	PNG_CRC_WARN_USE = 3;
	PNG_CRC_QUIET_USE = 4;
	PNG_CRC_NO_CHANGE = 5;

{...}

const
	PNG_NO_FILTERS = $00;
	PNG_FILTER_NONE = $08;
	PNG_FILTER_SUB = $10;
	PNG_FILTER_UP = $20;
	PNG_FILTER_AVG = $40;
	PNG_FILTER_PAETH = $80;
	PNG_ALL_FILTERS = PNG_FILTER_NONE or PNG_FILTER_SUB or PNG_FILTER_UP or PNG_FILTER_AVG or PNG_FILTER_PAETH;

	PNG_FILTER_VALUE_NONE = 0;
	PNG_FILTER_VALUE_SUB = 1;
	PNG_FILTER_VALUE_UP = 2;
	PNG_FILTER_VALUE_AVG = 3;
	PNG_FILTER_VALUE_PAETH = 4;
	PNG_FILTER_VALUE_LAST = 5;

{...}

const
	PNG_FILTER_HEURISTIC_DEFAULT = 0;
	PNG_FILTER_HEURISTIC_UNWEIGHTED = 1;
	PNG_FILTER_HEURISTIC_WEIGHTED = 2;
	PNG_FILTER_HEURISTIC_LAST = 3;

{...}

{$IFNDEF PNG_NO_STDIO}
procedure png_init_io(png_ptr: png_structp; fp: png_FILE_p); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$ENDIF}

{...}

function png_malloc(png_ptr: png_structp; size: png_uint_32): png_voidp; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

{$IFDEF PNG_1_0_X}
{...}
{$ELSE}
function png_malloc_warn(png_ptr: png_structp; size: png_uint_32): png_voidp; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$ENDIF}

procedure png_free( png_ptr : png_structp; ptr : png_voidp ); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

{$IFDEF PNG_1_0_X}
{...}
{$ENDIF}

procedure png_free_data(png_ptr: png_structp; info_ptr: png_infop; num: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$IFDEF PNG_FREE_ME_SUPPORTED}
procedure png_data_freer(png_ptr: png_structp; info_ptr: png_infop; freer: Integer; mask: png_uint_32); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$ENDIF}

const
	PNG_DESTROY_WILL_FREE_DATA = 1;
	PNG_SET_WILL_FREE_DATA = 1;
	PNG_USER_WILL_FREE_DATA = 2;

	PNG_FREE_HIST = $0008;
	PNG_FREE_ICCP = $0010;
	PNG_FREE_SPLT = $0020;
	PNG_FREE_ROWS = $0040;
	PNG_FREE_PCAL = $0080;
	PNG_FREE_SCAL = $0100;
	PNG_FREE_UNKN = $0200;
	PNG_FREE_LIST = $0400;
	PNG_FREE_PLTE = $1000;
	PNG_FREE_TRNS = $2000;
	PNG_FREE_TEXT = $4000;
	PNG_FREE_ALL = $7fff;
	PNG_FREE_MUL = $4220;

{$ifdef PNG_USER_MEM_SUPPORTED}
function png_malloc_default(png_ptr: png_structp; size: png_uint_32): png_voidp; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
procedure png_free_default(png_ptr: png_structp; ptr: png_voidp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$ENDIF}

function png_memcpy_check(png_ptr: png_structp; s1: png_voidp; s2: png_voidp; size: png_uint_32): png_voidp; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
function png_memset_check(png_ptr: png_structp; s1: png_voidp; value: Integer; size: png_uint_32): png_voidp; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

{$IFNDEF PNG_NO_ERROR_TEXT}
procedure png_error(png_ptr: png_structp; error: png_charp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
procedure png_chunk_error(png_ptr: png_structp; const mess: png_charp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$ELSE}
procedure png_err(png_ptr: png_structp);
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$ENDIF}

{$IFNDEF PNG_NO_WARNINGS}
procedure png_warning(png_ptr: png_structp; msg: png_charp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$IFDEF PNG_READ_SUPPORTED}
procedure png_chunk_warning(png_ptr: png_structp; const mess: png_charp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$ENDIF}
{$ENDIF}

{...}

function png_get_IHDR(png_ptr: png_structp; info_ptr: png_infop; width, height: png_uint_32p; bit_depth, color_type, interlace_method, compression_method, filter_method: PInteger): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
procedure png_set_IHDR(png_ptr: png_structp; info_ptr: png_infop; width, height: png_uint_32; bit_depth, color_type, interlace_method, compression_method, filter_method: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

{...}

{$IFDEF PNG_sCAL_SUPPORTED}
{$IFDEF PNG_FLOATING_POINT_SUPPORTED}
function png_get_sCAL(png_ptr: png_structp; info_ptr: png_infop; units: PInteger; width: png_uint_32p; height: png_uint_32): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$ELSE}
{$IFDEF PNG_FIXED_POINT_SUPPORTED}
function png_get_sCAL_s( png_ptr : png_structp; info_ptr : png_infop; units : PInteger; swidth : png_charpp; sheight : png_charpp ): png_uint_32; register;
{$ENDIF}
{$ENDIF}
{$ENDIF}

{$IFDEF PNG_sCAL_SUPPORTED}
{$IFDEF PNG_FLOATING_POINT_SUPPORTED}
procedure png_set_sCAL(png_ptr: png_structp; info_ptr: png_infop; units: Integer; width: double; height: double); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$ELSE}
{$IFDEF PNG_FIXED_POINT_SUPPORTED}
procedure png_set_sCAL_s(png_ptr: png_structp; info_ptr: png_infop; units: Integer; width: png_charp; height: png_charp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$ENDIF}
{$ENDIF}
{$ENDIF}

{...}

function png_get_copyright(png_ptr: png_structp): png_charp; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
function png_get_header_ver(png_ptr: png_structp): png_charp; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
function png_get_header_version(png_ptr: png_structp): png_charp; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
function png_get_libpng_ver(png_ptr: png_structp): png_charp; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

{$IFDEF PNG_MNG_FEATURES_SUPPORTED}
function png_permit_mng_features(png_ptr: png_structp; mng_features_permitted: png_uint_32): png_uint_32;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};
{$ENDIF}

const
	PNG_HANDLE_CHUNK_AS_DEFAULT = 0;
	PNG_HANDLE_CHUNK_NEVER = 1;
	PNG_HANDLE_CHUNK_IF_SAFE = 2;
	PNG_HANDLE_CHUNK_ALWAYS = 3;

{...}

{$IFDEF PNG_READ_COMPOSITE_NODIV_SUPPORTED}
function png_composite(fg, alpha, bg: png_byte): png_byte; inline;
function png_composite_16(fg, alpha, bg: png_uint_16): png_uint_16; inline;
{$ELSE}
function png_composite(fg, alpha, bg: png_byte): png_byte; inline;
function png_composite_16(fg, alpha, bg: png_uint_16): png_uint_16; inline;
{$ENDIF}

(***********************)

function png_get_PLTE(png_ptr: png_structp; info_ptr: png_infop; var palette: png_colorp; var num_palette: Integer): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_bKGD(png_ptr: png_structp; info_ptr: png_infop; var background: png_color_16p): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_bit_depth(png_ptr: png_structp; info_ptr: png_infop): png_byte; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_cHRM(png_ptr: png_structp; info_ptr: png_infop; var white_x, white_y, red_x, red_y, green_x, green_y, blue_x, blue_y: double): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_cHRM_fixed(png_ptr : png_structp; info_ptr : png_infop; int_white_x : png_fixed_point; int_white_y : png_fixed_point; int_red_x : png_fixed_point; int_red_y : png_fixed_point; int_green_x : png_fixed_point; int_green_y : png_fixed_point; int_blue_x : png_fixed_point; int_blue_y : png_fixed_point ): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_channels(png_ptr: png_structp; info_ptr: png_infop): png_byte; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_color_type(png_ptr: png_structp; info_ptr: png_infop): png_byte; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_compression_type(png_ptr: png_structp; info_ptr: png_infop): png_byte; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_error_ptr(png_ptr: png_structp): png_voidp; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_filter_type(png_ptr: png_structp; info_ptr: png_infop): png_byte; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_gAMA(png_ptr: png_structp; info_ptr: png_infop; var file_gamma: double): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_gAMA_fixed(png_ptr: png_structp; info_ptr: png_infop; var int_file_gamma : png_fixed_point ): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_hIST(png_ptr: png_structp; info_ptr: png_infop; var hist: png_uint_16p): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_iCCP(png_ptr: png_structp; info_ptr: png_infop; name: png_charpp; var compression_type: Integer; profile: png_charpp; proflen: png_int_32): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_image_height(png_ptr: png_structp; info_ptr: png_infop): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_image_width(png_ptr: png_structp; info_ptr: png_infop): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_interlace_type(png_ptr: png_structp; info_ptr: png_infop): png_byte; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_io_ptr(png_ptr: png_structp): png_voidp; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_oFFs(png_ptr: png_structp; info_ptr: png_infop; var offset_x, offset_y: png_uint_32; var unit_type: Integer): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_pCAL(png_ptr: png_structp; info_ptr: png_infop; var purpose: png_charp; var X0, X1: png_int_32; var typ, nparams: Integer; var units: png_charp; var params: png_charpp): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_pHYs(png_ptr: png_structp; info_ptr: png_infop; var res_x, res_y: png_uint_32; var unit_type: Integer): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_pixel_aspect_ratio(png_ptr: png_structp; info_ptr: png_infop): Single; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_pixels_per_meter(png_ptr: png_structp; info_ptr: png_infop): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_progressive_ptr(png_ptr: png_structp): png_voidp; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_rowbytes(png_ptr: png_structp; info_ptr: png_infop): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_rows(png_ptr: png_structp; info_ptr: png_infop): png_bytepp; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_sBIT(png_ptr: png_structp; info_ptr: png_infop; var sig_bits: png_color_8p): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_sPLT(png_ptr: png_structp; info_ptr: png_infop; entries: png_sPLT_tpp): png_uint_32;register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_sRGB(png_ptr: png_structp; info_ptr: png_infop; var file_srgb_intent: Integer): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_signature(png_ptr: png_structp; info_ptr: png_infop): png_bytep; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_text(png_ptr: png_structp; info_ptr: png_infop; var text_ptr: png_textp; var num_text: Integer): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_tIME(png_ptr: png_structp; info_ptr: png_infop; var mod_time: png_timep): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_tRNS(png_ptr: png_structp; info_ptr: png_infop; var trans: png_bytep; var num_trans: Integer; var trans_values: png_color_16p): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_unknown_chunks( png_ptr: png_structp; info_ptr: png_infop; entries : png_unknown_chunkpp ): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_user_chunk_ptr(png_ptr: png_structp): png_voidp; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_user_transform_ptr( png_ptr : png_structp ): png_voidp; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_valid(png_ptr: png_structp; info_ptr: png_infop; flag: png_uint_32): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_x_offset_microns(png_ptr: png_structp; info_ptr: png_infop): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_x_offset_pixels(png_ptr: png_structp; info_ptr: png_infop): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_x_pixels_per_meter(png_ptr: png_structp; info_ptr: png_infop): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_y_offset_microns(png_ptr: png_structp; info_ptr: png_infop): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_y_offset_pixels(png_ptr: png_structp; info_ptr: png_infop): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_get_y_pixels_per_meter(png_ptr: png_structp; info_ptr: png_infop): png_uint_32; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_permit_empty_plte( png_ptr: png_structp; empty_plte_permitted : Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_process_data(png_ptr: png_structp; info_ptr: png_infop; buffer: png_bytep; buffer_size: png_size_t); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_progressive_combine_row(png_ptr: png_structp; old_row, new_row: png_bytep); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_read_end(png_ptr: png_structp; info_ptr: png_infop); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_read_image(png_ptr: png_structp; image: png_bytepp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_read_png(png_ptr: png_structp; info_ptr: png_infop; transforms : Integer; params : Pointer ); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_read_row(png_ptr: png_structp; row, dsp_row: png_bytep); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_read_rows(png_ptr: png_structp; row, display_row: png_bytepp; num_rows: png_uint_32); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_read_update_info(png_ptr: png_structp; info_ptr: png_infop); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_PLTE(png_ptr: png_structp; info_ptr: png_infop; palette: png_colorp; num_palette: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_bKGD(png_ptr: png_structp; info_ptr: png_infop; background: png_color_16p); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_cHRM(png_ptr: png_structp; info_ptr: png_infop; white_x, white_y, red_x, red_y, green_x, green_y, blue_x, blue_y: double); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_cHRM_fixed(png_ptr: png_structp; info_ptr: png_infop; white_x, white_y, red_x, red_y, green_x, green_y, blue_x, blue_y: png_fixed_point); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_compression_level(png_ptr: png_structp; level: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_compression_mem_level(png_ptr: png_structp; mem_level: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_compression_method(png_ptr: png_structp; method: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_compression_strategy(png_ptr: png_structp; strategy: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_compression_window_bits(png_ptr: png_structp; window_bits: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_dither(png_ptr: png_structp; plaette: png_colorp; num_palette, maximum_colors: Integer; histogram: png_uint_16p; full_dither: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_error_fn(png_ptr: png_structp; error_ptr: png_voidp; error_fn, warning_fn: png_error_ptr); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_filler(png_ptr: png_structp; filler: png_uint_32; filler_loc: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_filter(png_ptr: png_structp; method, filters: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_filter_heuristics(png_ptr: png_structp; heuristic_method, num_weights: Integer; filter_weights, filter_costs: png_doublep); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_gAMA(png_ptr: png_structp; info_ptr: png_infop; file_gamma: double); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_gAMA_fixed(png_ptr: png_structp; info_ptr: png_infop; file_gamma: png_fixed_point); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_gamma(png_ptr: png_structp; screen_gamma, default_file_gamma: double); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_hIST(png_ptr: png_structp; info_ptr: png_infop; hist: png_uint_16p); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

function png_set_interlace_handling(png_ptr: png_structp): Integer; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_invert_mono(png_ptr: png_structp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_keep_unknown_chunks( png_ptr : png_structp; keep : Integer; chunk_list : png_bytep; num_chunks : Integer ); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_oFFs(png_ptr: png_structp; info_ptr: png_infop; offset_x, offset_y: png_uint_32; unit_type: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_pCAL(png_ptr: png_structp; info_ptr: png_infop; purpose: png_charp; X0, X1: png_int_32; typ, nparams: Integer; units: png_charp; params: png_charpp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_pHYs(png_ptr: png_structp; info_ptr: png_infop; res_x, res_y: png_uint_32; unit_type: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_packing(png_ptr: png_structp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_packswap(png_ptr: png_structp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_progressive_read_fn(png_ptr: png_structp; progressive_ptr: png_voidp; info_fn: png_progressive_info_ptr; row_fn: png_progressive_row_ptr; end_fn: png_progressive_end_ptr); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_read_fn(png_ptr : png_structp; io_ptr : png_voidp; read_data_fn : png_rw_ptr); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_read_status_fn(png_ptr: png_structp; read_row_fn: png_read_status_ptr); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_read_user_chunk_fn(png_ptr: png_structp; read_user_chunk_fn: png_user_chunk_ptr); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_read_user_transform_fn(png_ptr: png_structp; read_user_transform_fn: png_user_transform_ptr); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_rows(png_ptr: png_structp; info_ptr: png_infop; row_pointers: png_bytepp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_sBIT(png_ptr: png_structp; info_ptr: png_infop; sig_bits: png_color_8p); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_sRGB(png_ptr: png_structp; info_ptr: png_infop; intent: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_sRGB_gAMA_and_cHRM(png_ptr: png_structp; info_ptr: png_infop; intent: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_shift(png_ptr: png_structp; true_bits: png_color_8p); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_strip_16(png_ptr: png_structp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_swap(png_ptr: png_structp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_tIME(png_ptr: png_structp; info_ptr: png_infop; mod_time: png_timep); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_tRNS(png_ptr: png_structp; info_ptr: png_infop; trans: png_bytep; num_trans: Integer; trans_values: png_color_16p); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_text(png_ptr: png_structp; info_ptr: png_infop; text_ptr: png_textp; num_text: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_write_fn(png_ptr: png_structp; io_ptr : png_voidp; write_data_fn : png_rw_ptr; output_flush_fn : png_flush_ptr); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_write_status_fn(png_ptr: png_structp; write_row_fn: png_write_status_ptr); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_write_user_transform_fn(png_ptr: png_structp; write_user_transform_fn: png_user_transform_ptr); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_unknown_chunks( png_ptr: png_structp; info_ptr : png_infop; unknowns : png_unknown_chunkp; num_unknowns : Integer ) ; register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_user_transform_info(png_ptr: png_structp; user_transform_ptr : png_voidp; user_transform_depth : Integer; user_transform_channels : Integer ); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_start_read_image(png_ptr: png_structp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_write_end(png_ptr: png_structp; info_ptr: png_infop); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_write_image(png_ptr: png_structp; image: png_bytepp); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_write_png(png_ptr: png_structp; info_ptr: png_infop; transforms : Integer; params : Pointer ); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_write_row(png_ptr: png_structp; row: png_bytep); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_write_rows(png_ptr: png_structp; row: png_bytepp; num_rows: png_uint_32); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_iCCP(png_ptr: png_structp; info_ptr: png_infop; name: png_charp; compression_type: Integer; profile: png_charp; proflen: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

procedure png_set_sPLT(png_ptr: png_structp; info_ptr: png_infop; entries: png_sPLT_tp; nentries: Integer); register;
	external {$IFNDEF PNG_STATIC} libpng {$ENDIF};

implementation

{$IFDEF PNG_STATIC}
uses
	Windows;

function _memcmp(s1, s2: PChar; n: Integer): Integer; cdecl;
asm
	push esi
	push edi
	xor eax, eax
	mov ecx, n
	test ecx, ecx
	je @0
	mov esi, s1
	mov edi, s2
	repe cmpsb
	je @0
	ja @1
	dec eax
	jmp @0
@1:
	inc eax
@0:
	pop edi
	pop esi
end;

function _memset(s: Pointer; c, n: Integer): Pointer; cdecl;
begin
	FillChar(s^, n, c);
	Result := s;
end;

function _memcpy(dest, source: Pointer; count: Integer): Pointer; cdecl;
begin
	Move(source^, dest^, count);
	Result := dest
end;

function _snprintf(s: PChar; size: Integer; format: PChar; va: Char): Integer; cdecl;
begin
	Result := wvsprintfA(s, format, @va);
end;

function _strncpy(dest, src: PChar; n: Integer): PChar; cdecl;
begin
	Result := lstrcpynA(dest, src, n);
end;

function _strlen(s: PChar): Integer; cdecl;
begin
	Result := lstrlenA(s);
end;

var
	__turboFloat: Integer;

procedure __ftol; 
asm
	jmp System.@ROUND
end;

function _fabs(x: Double): Double; cdecl;
begin
	Result := Abs(x);
end;

function _pow(x, y: Double): Double; cdecl;
begin
	if x = 0 then
		Result := 0
	else if y = 0 then
		Result := 1
	else
		Result := Exp(Ln(x) * y);
end;

function _strtod(s: PChar; suffix: PPChar): Double; cdecl;
var
	P: Integer;
begin
	Val(s, Result, P);
	if suffix <> nil then
	begin
		if P = 0 then P := lstrlenA(s);
		suffix^ := s + P;
	end
end;

threadvar
	gmtimeResult: tm;

{splitting seconds since January 1, 1970}
function _gmtime(clock: time_t): ptm; cdecl;
var
	F: FILETIME; {100-nanosecond intervals since January 1, 1601}
	S: SYSTEMTIME;
begin
	Int64(F) := Int64(clock) * (10 * 1000 * 1000) + 116444736000000000;
	FileTimeToSystemTime(F, S);
	Result := @gmtimeResult;
	Result.tm_sec := S.wSecond;
	Result.tm_min := S.wMinute;
	Result.tm_hour := S.wHour;
	Result.tm_mday := S.wDay;
	Result.tm_mon := S.wMonth;
	Result.tm_year := S.wYear;
	Result.tm_wday := S.wDayOfWeek;
	Result.tm_yday := S.wDay;
	Result.tm_isdst := 0;
end;

function _malloc(Size: Integer): Pointer; cdecl;
begin
	GetMem(Result, Size);
end;

procedure _free(Block: Pointer); cdecl;
begin
	FreeMem(Block);
end;

procedure _abort; cdecl;
begin
	Halt(1);
end;

{$IFDEF PNG_SETJMP_SUPPORTED}
type
	{struct jmp_buf of Borland C++}
	jmp_buf = record
		j_ebp: Cardinal;
		j_ebx: Cardinal;
		j_edi: Cardinal;
		j_esi: Cardinal;
		j_esp: Cardinal;
		j_ret: Cardinal;
		j_excep: Cardinal;
		j_context: Cardinal;
	end;

procedure _setjmp;
asm
	mov	eax, [fs:0]                       { get exception error record }
	//push eax
	//call _CurrExcContext                { get exception context }
	mov	edx, eax
	pop ecx                               { get return address }
	pop eax                               { get pointer to jmp_buf }
	mov jmp_buf[eax].j_ebp, ebp           { save EBP }
	mov jmp_buf[eax].j_ebx, ebx           { save EBX }
	mov jmp_buf[eax].j_edi, edi           { save EDI }
	mov jmp_buf[eax].j_esi, esi           { save ESI }
	mov jmp_buf[eax].j_esp, esp           { save ESP }
	mov jmp_buf[eax].j_ret, ecx           { save return address }
	mov jmp_buf[eax].j_context, edx       { save context number }
	mov edx, [fs:0]                       { get head of exception chain }
	mov jmp_buf[eax].j_excep, edx         { save it }
	xor eax, eax                          { always return 0 }
	sub esp, 4                            { fake setjmp arg for caller to pop }
	//jmp ecx                             { return }
	push ecx { Do not break CPU expecting call-ret pair (diff with cpprtl) }
	ret
end;

procedure _longjmp;
asm
	pop eax                               { discard return address }
	mov ecx, [esp]                        { get jmp_buf address }
	mov eax, jmp_buf[ecx].j_excep         { address of excep. reg. record }
	cmp eax, [fs:0]                       { if the exception list hasn't changed, }
	je @no_global_unwind                  { don't bother to unwind }
	//push dword [ebp-4]
	//mov dword [ebp-4], esp              { save ESP since it gets trashed }
	//push 0                              { NULL exc. }
	//push return                         { address of new EIP (simulate return) }
	//push eax                            { exc. reg. record }
	//call RtlUnwind                      { unwind exceptions }
@return:
	//mov esp, [ebp-4]                    { restore ESP }
	//pop dword [ebp-4]
	mov ecx, [esp]                        { get jmp_buf address }
	mov eax, jmp_buf[ecx].j_excep         { address of excep. reg. record }
	mov [fs:0], eax                       { set fs:0 for safety }
@no_global_unwind:
	//push eax
	//call _CurrExcContext
	//add	esp, 4
	//cmp	eax, -1                         { check if exception record is ours }
	//je done_unwind                      { if not then done }
	//mov ecx,[esp]                       { get jmp_buf address }
	//cmp eax,[ecx+j_context]             { check if context records are same }
	//je done_unwind                      { if so then done }
	//push dword jmp_buf[ecx].j_context
	//push dword jmp_buf[ecx].j_excep
	//call _Local_unwind
	//add	esp, 8
@done_unwind:
	pop ecx                               { get pointer to jmp_buf }
	{ Restore registers and return to original setjmp() caller. }
	pop eax                               { get return value }
	cmp eax, 1                            { disallow zero return }
	adc eax, 0                            { eax += (eax == 0) }
	mov ebp, jmp_buf[ecx].j_ebp           { restore EBP }
	mov ebx, jmp_buf[ecx].j_ebx           { restore EBX }
	mov edi, jmp_buf[ecx].j_edi           { restore EDI }
	mov esi, jmp_buf[ecx].j_esi           { restore ESI }
	mov esp, jmp_buf[ecx].j_esp           { restore ESP }
	sub esp, 4                            { fake setjmp arg for caller to pop }
@__DoLongJump__:
	jmp jmp_buf[ecx].j_ret                { jump to return address }
end;
{$ENDIF}

{$L pngpread.obj}
{$L pngread.obj}
{$L pngrutil.obj}
{$L pngrtran.obj}
{$L pngwrite.obj}
{$L pngwtran.obj}
{$L pngtrans.obj}
{$L pngerror.obj}
{$L pngget.obj}
{$L pngrio.obj}
{$L pngset.obj}
{$L pngwutil.obj}
{$L pngwio.obj}
{$L pngmem.obj}
{$L png.obj}

{$ENDIF}

{$IFDEF PNG_READ_COMPOSITE_NODIV_SUPPORTED}

function png_composite(fg, alpha, bg: png_byte): png_byte;
var
	temp: png_uint_16;
begin
	temp := fg * alpha + bg * (255 - alpha) + 128;
	result := (temp + (temp shr 8)) shr 8;
end;

function png_composite_16(fg, alpha, bg: png_uint_16): png_uint_16;
var
	temp: png_uint_32;
begin
	temp := fg * Alpha + bg * (65535 - Alpha) + 32768;
	result := (temp + (temp shr 16)) shr 16;
end;

{$ELSE}

function png_composite(fg, alpha, bg: png_byte): png_byte;
begin
	result := (fg * alpha + bg * (255 - alpha) + 127) div 255;
end;

function png_composite_16(fg, alpha, bg: png_uint_16): png_uint_16;
begin
	result := (fg * alpha + bg * (65535 - alpha) + 32767) div 65535;
end;

{$ENDIF}

end.
